package es.uva.tfg.geolocalizationgame.exceptions;

/**
 * Clase de excepcion cuando el juego no es visible para el usuario.
 * 
 * @author Cristina Gomez Escribano
 * @since 29/11/2018
 * @version 1.0
 * 
 */
public class JuegoNotVisibleForUserException extends Exception {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public static final String DESCRIPTION = "El juego no está disponible para este usuario";
	public static final int CODE = 125;

	public JuegoNotVisibleForUserException() {
		this("");
	}

	public JuegoNotVisibleForUserException(String detail) {
		super(DESCRIPTION + ". " + detail + ". CODE: " + CODE);
	}
}
