package es.uva.tfg.geolocalizationgame.exceptions;

import java.util.List;

import es.uva.tfg.geolocalizationgame.resources.ErrorMessage;

/**
 * Clase de excepcion cuando la peticion no es correcta.
 * 
 * @author Cristina Gomez Escribano
 * @since 29/11/2018
 * @version 1.0
 * 
 */
public class MalformedRequestException extends Exception {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public static final String DESCRIPTION = "Los datos enviados son inválidos";
	public static final int CODE = 112;

	public MalformedRequestException() {
		this("");
	}

	public MalformedRequestException(String detail) {
		super(DESCRIPTION + ". " +detail +". CODE: " + CODE);
	}
	
	public MalformedRequestException(List<ErrorMessage> listaErrores) {
		super(DESCRIPTION + ". "+ listaErrores + ". CODE: "+CODE);
	}
}
