package es.uva.tfg.geolocalizationgame.persistence;

import java.io.Serializable;
import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import es.uva.tfg.geolocalizationgame.resources.Comentario;
import es.uva.tfg.geolocalizationgame.resources.Juego;


/**
 *  Implementa la clase de persistencia para la entidad Comentario.
 *  
 * @author Cristina Gomez Escribano
 * @since 10/11/2018
 * @version 1.0
 *
 */
public interface ComentarioRepository extends JpaRepository<Comentario, Serializable> {

	/**
	 * Devuelve los comentarios de un juego. 
	 * 
	 * @param juego
	 * @return List<Comentario>
	 */
	@Query("SELECT comentario FROM Comentario comentario WHERE comentario.juego=:juego")
	List<Comentario> getComentariosByJuego(@Param(value="juego") Juego juego);

}
