package es.uva.tfg.geolocalizationgame.persistence;

import java.io.Serializable;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import es.uva.tfg.geolocalizationgame.resources.EstadoSolicitudAmistad;

/**
 *  Implementa la clase de persistencia para la entidad EstadoSolcitud.
 *  
 * @author Cristina Gomez Escribano
 * @since 10/11/2018
 * @version 1.0
 *
 */
public interface EstadoSolicitudRepository extends JpaRepository<EstadoSolicitudAmistad, Serializable>{

	/**
	 * Obtiene un estado de la solicitud por nombre.
	 * 
	 * @param nombre
	 * @return EstadoSolicitudAmistad
	 */
	@Query("SELECT estadosol FROM EstadoSolicitudAmistad estadosol WHERE estadosol.estado=:nombre")
	EstadoSolicitudAmistad obtenerEstadoPorNombre(@Param(value="nombre") String nombre);
}
