package es.uva.tfg.geolocalizationgame.persistence;

import java.io.Serializable;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import es.uva.tfg.geolocalizationgame.resources.ModalidadDeJuego;

/**
 * Implementa la clase de persistencia para la entidad ModalidadDeJuego.
 * 
 * @author Cristina Gomez Escribano
 * @since 29/11/2018
 * @version 1.0
 *
 */
public interface ModalidadDeJuegoRepository extends JpaRepository<ModalidadDeJuego, Serializable> {

	/**
	 * Obtiene la modalidad de juego que contiene la palabra que se esta pasando como parametro.
	 * 
	 * @param nombreModo
	 * @return
	 */
	@Query("select modo from ModalidadDeJuego modo where (UPPER(modo.modalidad) LIKE CONCAT('%',:nombreModo,'%'))")
	ModalidadDeJuego obtenerModalidadDeJuegoByNombre(@Param(value = "nombreModo") String nombreModo);
}
