package es.uva.tfg.geolocalizationgame.resources;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * Representa una solicitud de amistad en la base de datos
 * @author Cristina Gómez Escribano
 * @version 1.0
 *
 */
@Entity
@Table(name = "estado_solicitud_amistad")
public class EstadoSolicitudAmistad implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name="ID_ESTADO_SOLICITUD", unique = true)
	@JsonView(DatosUser.Basic.class)
	private Integer idEstadoSolicitud;
	
	@Column(name="ESTADO")
	@NotNull
	@JsonView(DatosUser.Basic.class)
	private String estado;
	
	public EstadoSolicitudAmistad() {
		super();
	}

	public EstadoSolicitudAmistad(Integer idEstadoSolicitud, String estado) {
		super();
		this.idEstadoSolicitud = idEstadoSolicitud;
		this.estado = estado;
	}

	public Integer getIdEstadoSolicitud() {
		return idEstadoSolicitud;
	}

	public void setIdEstadoSolicitud(Integer idEstadoSolicitud) {
		this.idEstadoSolicitud = idEstadoSolicitud;
	}

	public String getEstado() {
		return estado;
	}

	public void setEstado(String estado) {
		this.estado = estado;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((estado == null) ? 0 : estado.hashCode());
		result = prime * result + ((idEstadoSolicitud == null) ? 0 : idEstadoSolicitud.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		EstadoSolicitudAmistad other = (EstadoSolicitudAmistad) obj;
		if (estado == null) {
			if (other.estado != null)
				return false;
		} else if (!estado.equals(other.estado))
			return false;
		if (idEstadoSolicitud == null) {
			if (other.idEstadoSolicitud != null)
				return false;
		} else if (!idEstadoSolicitud.equals(other.idEstadoSolicitud))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "EstadoSolicitudAmistad [idEstadoSolicitud=" + idEstadoSolicitud + ", estado=" + estado + "]";
	}
}
