package es.uva.tfg.geolocalizationgame.resources;

import java.io.Serializable;

import javax.persistence.Embeddable;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * Implementa la clave primaria de una instancia de la clase Logro
 * 
 * @author Cristina Gómez Escribano
 * @since 16/09/2018
 * @version 1.0
 *
 */
@Embeddable
public class LogroPK implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@ManyToOne
	@JoinColumn(name="LOGIN_LOGRO")
	private Usuario usuario;
	
	@JoinColumn(name="ID_TIPO_LOGRO", referencedColumnName="ID_TIPO_LOGRO", nullable=false)
	@JsonView(DatosUser.PrivateProfile.class)
	@ManyToOne(optional=false)
	private TipoLogro tipoLogro;
	
	public LogroPK() {
		super();
	}

	public LogroPK(Usuario usuario, TipoLogro tipoLogro) {
		super();
		this.usuario = usuario;
		this.tipoLogro = tipoLogro;
	}

	public Usuario getUsuario() {
		return usuario;
	}
	
	public void setUsuario(Usuario usuario) {
		this.usuario = usuario;
	}
	
	public TipoLogro getTipoLogro() {
		return tipoLogro;
	}
	
	public void setTipoLogro(TipoLogro tipoLogro) {
		this.tipoLogro = tipoLogro;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((tipoLogro == null) ? 0 : tipoLogro.hashCode());
		result = prime * result + ((usuario == null) ? 0 : usuario.hashCode());
		return result;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		LogroPK other = (LogroPK) obj;
		if (tipoLogro == null) {
			if (other.tipoLogro != null)
				return false;
		} else if (!tipoLogro.equals(other.tipoLogro))
			return false;
		if (usuario == null) {
			if (other.usuario != null)
				return false;
		} else if (!usuario.equals(other.usuario))
			return false;
		return true;
	}
}
