package es.uva.tfg.geolocalizationgame.resources;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

/**
 * Definicion de la entidad ModalidadDeJuego.
 * 
 * @author Cristina Gomez Escribano
 * @version 2.0
 * @since 10/10/2018
 *
 */
@Entity
@Table(name = "modalidad_juego")
public class ModalidadDeJuego implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name="ID_MODALIDAD", unique = true)
	private Integer idModalidad;
	
	@Column(name="MODALIDAD")
	@NotNull
	private String modalidad;

	public ModalidadDeJuego() {
		super();
	}

	public ModalidadDeJuego(Integer idModalidad, String modalidad) {
		super();
		this.idModalidad = idModalidad;
		this.modalidad = modalidad;
	}

	public Integer getIdModalidad() {
		return idModalidad;
	}

	public void setIdModalidad(Integer idModalidad) {
		this.idModalidad = idModalidad;
	}

	public String getModalidad() {
		return modalidad;
	}

	public void setModalidad(String modalidad) {
		this.modalidad = modalidad;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((idModalidad == null) ? 0 : idModalidad.hashCode());
		result = prime * result + ((modalidad == null) ? 0 : modalidad.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ModalidadDeJuego other = (ModalidadDeJuego) obj;
		if (idModalidad == null) {
			if (other.idModalidad != null)
				return false;
		} else if (!idModalidad.equals(other.idModalidad))
			return false;
		if (modalidad == null) {
			if (other.modalidad != null)
				return false;
		} else if (!modalidad.equals(other.modalidad))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "ModalidadDeJuego [idModalidad=" + idModalidad + ", modalidad=" + modalidad + "]";
	}
}
