package es.uva.tfg.geolocalizationgame.resources;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * Definicion de la entidad TipoPunto.
 * 
 * @author Cristina Gomez Escribano
 * @version 2.0
 * @since 11/11/2018
 *
 */
@Entity
@Table(name="tipo_punto")
public class TipoPunto implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name="ID_TIPO_PUNTO", unique = true)
	@JsonView(DatosUser.GameView.class)
	private Integer idTipoPunto;
	
	@Column(name="TIPO_PUNTO")
	@NotNull
	@JsonView(DatosUser.GameView.class)
	private String tipoPunto;

	public TipoPunto() {
		super();
	}

	public TipoPunto(Integer idTipoPunto, String tipoPunto) {
		super();
		this.idTipoPunto = idTipoPunto;
		this.tipoPunto = tipoPunto;
	}

	public Integer getIdTipoPunto() {
		return idTipoPunto;
	}

	public void setIdTipoPunto(Integer idTipoPunto) {
		this.idTipoPunto = idTipoPunto;
	}

	public String getTipoPunto() {
		return tipoPunto;
	}

	public void setTipoPunto(String tipoPunto) {
		this.tipoPunto = tipoPunto;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((idTipoPunto == null) ? 0 : idTipoPunto.hashCode());
		result = prime * result + ((tipoPunto == null) ? 0 : tipoPunto.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TipoPunto other = (TipoPunto) obj;
		if (idTipoPunto == null) {
			if (other.idTipoPunto != null)
				return false;
		} else if (!idTipoPunto.equals(other.idTipoPunto))
			return false;
		if (tipoPunto == null) {
			if (other.tipoPunto != null)
				return false;
		} else if (!tipoPunto.equals(other.tipoPunto))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "TipoPunto [idTipoPunto=" + idTipoPunto + ", tipoPunto=" + tipoPunto + "]";
	}
}
