package es.uva.tfg.geolocalizationgame.resources;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonView;

/**
 * Definicion de la entidad TipoVisibilidad.
 * 
 * @author Cristina Gomez Escribano
 * @version 2.0
 * @since 11/11/2018
 *
 */
@Entity
@Table(name = "tipo_visibilidad")
public class TipoVisibilidad implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@Column(name="ID_TIPO_VISIBILIDAD", unique = true)
	@JsonView(DatosUser.PrivateProfile.class)
	private Integer idTipoVisibilidad;
	
	@Column(name="TIPO_VISIBILIDAD")
	@NotNull
	@JsonView(DatosUser.PrivateProfile.class)
	private String tipoVisibilidad;

	public TipoVisibilidad() {
		super();
	}

	public TipoVisibilidad(Integer idTipoVisibilidad, String tipoVisibilidad) {
		super();
		this.idTipoVisibilidad = idTipoVisibilidad;
		this.tipoVisibilidad = tipoVisibilidad;
	}
	
	public Integer getIdTipoVisibilidad() {
		return idTipoVisibilidad;
	}

	public void setIdTipoVisibilidad(Integer idTipoVisibilidad) {
		this.idTipoVisibilidad = idTipoVisibilidad;
	}

	public String getTipoVisibilidad() {
		return tipoVisibilidad;
	}

	public void setTipoVisibilidad(String tipoVisibilidad) {
		this.tipoVisibilidad = tipoVisibilidad;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((idTipoVisibilidad == null) ? 0 : idTipoVisibilidad.hashCode());
		result = prime * result + ((tipoVisibilidad == null) ? 0 : tipoVisibilidad.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TipoVisibilidad other = (TipoVisibilidad) obj;
		if (idTipoVisibilidad == null) {
			if (other.idTipoVisibilidad != null)
				return false;
		} else if (!idTipoVisibilidad.equals(other.idTipoVisibilidad))
			return false;
		if (tipoVisibilidad == null) {
			if (other.tipoVisibilidad != null)
				return false;
		} else if (!tipoVisibilidad.equals(other.tipoVisibilidad))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "TipoVisibilidad [idTipoVisibilidad=" + idTipoVisibilidad + ", tipoVisibilidad=" + tipoVisibilidad + "]";
	}
}
