package es.uva.tfg.geolocalizationgame.services;

import es.uva.tfg.geolocalizationgame.resources.TipoVisibilidad;

/**
 * Interfaz del servicio para la entidad TipoVisibilidad.
 * 
 * @author Cristina Gómez Escribano
 * @since 02/11/2018
 * @version 1.0
 *
 */
public interface TipoVisibilidadService {

	/**
	 * Devuelve un tipo de visibilidad por nombre.
	 * 
	 * @param nombre
	 * @return TipoVisibilidad
	 */
	TipoVisibilidad obtenerVisibilidadByNombre(String nombre);

	/**
	 * Devuelve un tipo de visibilidad por id.
	 * @param idVisibilidad
	 * @return TipoVisibilidad
	 */
	TipoVisibilidad obtenerVisibilidadById(Integer idVisibilidad);

}
