package es.uva.tfg.geolocalizationgame.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import es.uva.tfg.geolocalizationgame.persistence.TipoVisibilidadRepository;
import es.uva.tfg.geolocalizationgame.resources.TipoVisibilidad;

/**
 * Implementacion del servicio para la entidad TipoVisibilidad.
 * 
 * @author Cristina Gómez Escribano
 * @since 02/11/2018
 * @version 1.0
 *
 */
@Service
public class TipoVisibilidadServiceImpl implements TipoVisibilidadService{

	@Autowired
	private TipoVisibilidadRepository tipoVisibilidadRepository;
	@Override
	public TipoVisibilidad obtenerVisibilidadByNombre(String nombre) {
		return tipoVisibilidadRepository.obtenerVisibilidadByNombre(nombre);
	}
	
	@Override
	public TipoVisibilidad obtenerVisibilidadById(Integer idVisibilidad) {
		return tipoVisibilidadRepository.findOne(idVisibilidad);
	}

}
