app.controller('NotificacionesController', function($rootScope, $scope, $http, $location, UserService, SolicitudAmistadService) {
	scrollToTopNoAnimated();
	$rootScope.portada=false;
	var estadoAceptada="Aceptada";
	var estadoRechazada="Rechazada";
	$scope.solicitudAceptadaOk=false;
	$scope.errorAgregarAmigo=false;
	$scope.idSolicitud="";
	$scope.loginUsuario="";
	var loginAmigo="";
	$scope.usuario=$rootScope.user;
	
	/**
	 * Abrir el perfil del usuario seleccionado
	 */
	$scope.openUser = function (login) {
		
		if(login){//tengo usuario seleccionado
			$location.path("/home/users/"+login);
		}
	};
	
	/**
	 * Abrir el juego seleccionado
	 */
	$scope.openGame = function (idJuego) {
		
		if(idJuego){//tengo usuario seleccionado
			$location.path("/home/juegos/"+idJuego);
		}
	};
	
	/**
	 * 
	 */
	$scope.agregarAmigo = function () {
		loginAmigo=$scope.loginUsuario;
		SolicitudAmistadService.actualizarSolicitud($scope.idSolicitud, estadoAceptada)
			.then(function success(response){
				console.log("cambiada a aceptada");
				UserService.updateAmigosUser($scope.usuario.login,loginAmigo, true)
				.then(function success(response){
					console.log("agregado amigo");
					obtenerSolicitudesRecibidas();
					obtenerAmigos();
					$scope.solicitudAceptadaOk=true;
					$scope.errorAgregarAmigo=false;
					$scope.solicitudRechazadaOk=false;
					$scope.solicitudRechazadaKo=false;
					scrollToTop();
				},function error(error){
					$scope.solicitudAceptadaOk=false;
					$scope.errorAgregarAmigo=true;
					$scope.solicitudRechazadaOk=false;
					$scope.solicitudRechazadaKo=false;
					console.log("no agregado amigo");
					scrollToTop();
				});
			},
			function error(error){
				$scope.solicitudAceptadaOk=false;
				$scope.errorAgregarAmigo=true;
				scrollToTop();
			});
	};
	
	/**
	 * 
	 */
	$scope.rechazarSolicitud = function(){
		SolicitudAmistadService.actualizarSolicitud($scope.idSolicitud, estadoRechazada)
		.then(function success(response){
			obtenerSolicitudesRecibidas();
			$scope.solicitudRechazadaOk=true;
			$scope.solicitudRechazadaKo=false;
			$scope.solicitudAceptadaOk=false;
			$scope.errorAgregarAmigo=false;
			scrollToTop();
		},
		function error(error){
			$scope.solicitudAceptadaOk=false;
			$scope.solicitudRechazadaKo=true;
			$scope.solicitudAceptadaOk=false;
			$scope.errorAgregarAmigo=false;
			scrollToTop();
		});
	};
	
	/**
	 * Para mostrar los datos del usuario de la solicitud en el modal
	 */
	$("#acceptModal,#refusedModal").on("show.bs.modal", function(e){
		var nombreEmisor=$(e.relatedTarget).data().nombre;
		$scope.loginUsuario=$(e.relatedTarget).data().login;
		$scope.idSolicitud=$(e.relatedTarget).data().id;//guardamos el id de la solicitud
		$(e.currentTarget).find(".nombreUser").text(nombreEmisor);
	});
	
	/**
	 * Eliminar el usuario seleccionado al salir del modal
	 */
	$("#acceptModal,#refusedModal").on("hidden.bs.modal", function(e){
		$scope.idSolicitud="";
		$scope.loginUsuario="";
	});
	
	function obtenerSolicitudesRecibidas () {
		SolicitudAmistadService.obtenerSolicitudesRecibidas($rootScope.user.login, "Pendiente").then(
				function success(response){
					$rootScope.user.solicitudesRecibidas=response;
				},
				function error(error){
					$rootScope.user.solicitudesRecibidas={};
				}
			);
	};
	
	function obtenerAmigos() {
		UserService.getAmigos($rootScope.user.login).then(
			function success(response) {
				$rootScope.user.amigos = response;
			}, function error(error) {
				$rootScope.user.amigos = {};
			});

	}
	;
});