app.service("UserService", function($http, $q) {

	var user = undefined;
	var login = undefined;
	var userPass = undefined;
	var searchUsers = undefined;
	var userSearch = undefined;
	var updateAmigos = undefined;
	var amigos = undefined;
	this.userRegister = false;
	this.userAuth = false;

	this.getUserAuth = function() {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get('/authentication').then(function(response) {
			user = response.data;
			defered.resolve(user);
		},
			function error(error) {
				defered.reject(error);
			});

		return promise;
	};

	this.loginUser = function(credentials) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.post('login', $.param(credentials), {
			headers : {
				"content-type" : "application/x-www-form-urlencoded"
			}
		}).then(function(response) {
			login = response.data;
			defered.resolve(login);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
	};

	this.registerUser = function(user) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.post("/usuarios/registro", {
			login : user.username,
			nombre : user.nombre,
			email : user.mail,
			password : user.password,
			avatar : "0" //avatar por defecto
		}).then(function(response) {
			register = response.data;
			defered.resolve(register);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
	};

	this.logoutUser = function() {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.post('logout', {})
			.then(function(response) {
				logoutUser = response.data;
				defered.resolve(logoutUser);
			},
				function error(error) {
					defered.reject(error);
				});
		return promise;
	};

	this.updatePersonalData = function(newUser) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.put("/usuarios/" + newUser.login, {
			nombre : newUser.nombre,
			email : newUser.email,
			password : newUser.password,
			avatar : newUser.avatar
		}).then(function(response) {
			user = response.data;
			defered.resolve(user);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
	};

	this.updatePersonalDataPass = function(newUserPass) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.put("/usuarios/" + newUserPass.login, {
			currentPassword : newUserPass.currentPassword,
			newPassword : newUserPass.newPassword
		}).then(function(response) {
			userPass = response.data;
			defered.resolve(userPass);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
	};

	this.updateAmigosUser = function(usuario, amigo, agregarAmigo) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.put("/usuarios/" + usuario + "/amigos/"+amigo+"/?agregarAmigo="+agregarAmigo).then(function(response) {
			updateAmigos = response.data;
			defered.resolve(updateAmigos);
		}, function error(error) {
			defered.reject(error);
		});
		return promise;
	};

	this.getAmigos = function(usuario) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/usuarios/" + usuario + "/amigos").then(function(response) {
			amigos = response.data;
			defered.resolve(amigos);
		}, function error(error) {
			searchUsers = undefined;
			defered.reject(error);
		});
		return promise;
	};

	this.getUsersByText = function(text) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/usuarios?text=" + text).then(function(response) {
			searchUsers = response.data;
			defered.resolve(searchUsers);
		}, function error(error) {
			searchUsers = undefined;
			defered.reject(error);
		});
		return promise;
	};

	this.getUserByLogin = function(login) {
		var defered = $q.defer();
		var promise = defered.promise;
		$http.get("/usuarios/" + login).then(function(response) {
			userSearch = response.data;
			defered.resolve(userSearch);
		}, function error(error) {
			userSearch = undefined;
			defered.reject(error);
		});
		return promise;
	};

	this.getSearchUsers = function() {
		return searchUsers;
	};

	this.getUser = function() {
		return user;
	};
});