app.controller('LoginController',
	function($rootScope, $scope, $location, UserService, SolicitudAmistadService) {
		scrollToTopNoAnimated();
		$rootScope.portada=false;
		$scope.credentials = {};
		$scope.userRegister = UserService.userRegister; //ver si el usuario se ha registrado correctamente

		var authenticate = function(callback) {
			UserService.getUserAuth().then(
				function success(response) {
					if (response.login) { //se ha logueado
						console.log("Existe usuario logado");
						$rootScope.user = UserService.getUser(); //guardar el usuario logado
						obtenerSolicitudes();
						obtenerAmigos();
						UserService.userAuth = true;
						$rootScope.authenticated = true;
					} else {
						$rootScope.authenticated = false;
						UserService.userAuth = false;
						console.log("No hay usuario logueado");
						console.log(response);
					}
					callback && callback();
				},
				function error(error) {
					$rootScope.authenticated = false;
					UserService.userAuth = false;
					console.log("Error en devolver el usuario autenticado");
					callback && callback();
				});
		};

		function obtenerSolicitudes() {
			SolicitudAmistadService.obtenerSolicitudesEnviadas($rootScope.user.login, "Pendiente").then(
				function success(response) {
					$rootScope.user.solicitudesEnviadas = response;
				},
				function error(error) {
					$rootScope.user.solicitudesEnviadas = {};
				}
			);
			SolicitudAmistadService.obtenerSolicitudesRecibidas($rootScope.user.login, "Pendiente").then(
				function success(response) {
					$rootScope.user.solicitudesRecibidas = response;
				},
				function error(error) {
					$rootScope.user.solicitudesRecibidas = {};
				}
			);
		}
		;

		function obtenerAmigos() {
			UserService.getAmigos($rootScope.user.login).then(
				function success(response) {
					$rootScope.user.amigos = response;
					obtenerLogrosCompartidos();
					obtenerJuegosCompartidos();
					console.log($rootScope.user);
				}, function error(error) {
					$rootScope.user.amigos = {};
				});

		}
		;

		$scope.login = function() {
			UserService.userRegister = false;
			$scope.userRegister = false;
			$scope.credentials.username=$scope.credentials.username.replace(" ","");
			UserService.loginUser($scope.credentials)
				.then(
					function success(data) {
						authenticate(function() {
							console.log("Exito en ejecucion de login");
							if ($rootScope.authenticated) {
								$location.path("/home");
								$scope.error = false;
							} else {
								$location.path("/login");
								$scope.error = true;
							}

						})
					},
					function error(error) {
						console.log("Error en el login");
						$location.path("/login");
						$scope.error = true;
						$rootScope.authenticated = false;
					}
			);
		};
		
		/**
		 * Guarda los logros compartidos por los amigos con visibilidad amigos
		 */
		function obtenerLogrosCompartidos(){
			$rootScope.user.logrosCompartidos=[];
			jQuery.each($rootScope.user.amigos, function(i, amigo) {
				jQuery.each(amigo.logros, function(j, logro) {
					if (logro.tipoVisibilidad.tipoVisibilidad === "amigos") {
						logro.usuario=amigo;
						$rootScope.user.logrosCompartidos.push(logro);
					}
				});
			});
		};
		
		/**
		 * Guarda los juegos compartidos por los amigos con visibilidad amigos
		 */
		function obtenerJuegosCompartidos(){
			$rootScope.user.juegosCompartidos=[];
			jQuery.each($rootScope.user.amigos, function(i, amigo) {
				jQuery.each(amigo.juegos, function(j, juego) {
					if (juego.visibilidad.tipoVisibilidad === "amigos") {
						juego.usuario=amigo;
						$rootScope.user.juegosCompartidos.push(juego);
					}
				});
			});
		};
	});