app.controller('PerfilUsuarioController', function($scope, $rootScope, $location, UserService, SolicitudAmistadService) {
	scrollToTopNoAnimated();
	$rootScope.portada=false;
	var estadoPendiente = "Pendiente";
	var login = undefined;
	$scope.solicitudPendiente = false;
	$scope.usuario = null;
	$scope.solicitudOk = false;
	$scope.existSolicitud = false;
	$scope.error = false;
	$scope.amigo = false;
	getUsuario();
	$scope.amigos = $rootScope.user.amigos;

	//Pensar en guardarlo cuando venga de busqueda para no hacer llamada sin necesidad
	function getUsuario() {
		login = $location.path().substr($location.path().lastIndexOf("/") + 1);
		
		if(login===$rootScope.user.login){//evitar que el usuario logueado acceda a su perfil publico
			$location.path("/home");
		}else {
			UserService.getUserByLogin(login) //obtener el usuario solicitado
			.then(function success(response) {
				$scope.usuario = response;
				comprobarAmigo();
				if (!$scope.amigo) { //miramos si tiene solcitudes pendientes con este usuario ya que no son amigos
					comprobarSolicitudPendiente();
					obtenerLogrosPublicos();
				}
				console.log("Cargado perfil de usuario: "+ JSON.stringify($scope.usuario));
			}, function error(error) {
				$scope.usuario = null;
				$location.path("/home");
			});
		}
	}
	;

	/**
	 * Para deshabilitar el boton de enviar solicitud si es que ya está enviada
	 */
	function comprobarSolicitudPendiente() {
		var solicitudesRecibidas = SolicitudAmistadService.getSolicitudesRecibidas();
		var solicitudesEnviadas = SolicitudAmistadService.getSolicitudesEnviadas();
		jQuery.each(solicitudesRecibidas, function() {
			if (this.emisor.login === $scope.usuario.login && this.estadoSolicitud.estado === "Pendiente") {
				$scope.solicitudPendiente = true;
			}
		});
		if (!$scope.solicitudPendiente) {
			jQuery.each(solicitudesEnviadas, function() {
				if (this.receptor.login === $scope.usuario.login && this.estadoSolicitud.estado === "Pendiente") {
					$scope.solicitudPendiente = true;
				}
			});
		}
	}
	;
	
	/**
	 * Comprueba si este usuario es amigo del usuario logado
	 */
	function comprobarAmigo() {
		var amigos = $rootScope.user.amigos;
		jQuery.each(amigos, function() {
			if (this.login === login) { //ya son amigos
				$scope.amigo = true;
			}
		});
	}
	;

	$scope.agregarAmigo = function() {
		var emisor = $rootScope.user.login;
		var receptor = $scope.usuario.login;
		SolicitudAmistadService.postSolicitud(emisor, receptor)
			.then(function success(response) {
				SolicitudAmistadService.obtenerSolicitudesEnviadas($rootScope.user.login, estadoPendiente).then( //para actualizar las solicitudes enviadas
					function success(response) {
						comprobarSolicitudPendiente();
					},
					function error(error) {});
					$scope.solicitudOk = true;
					$scope.existSolicitud = false;
					$scope.error = false;
					$scope.eliminarAmigoOk=false;
					$scope.eliminarAmigoKo=false;
					scrollToTop();
		},
				function error(error) {
					$scope.solicitudOk = false;
					$scope.eliminarAmigoOk=false;
					$scope.eliminarAmigoKo=false;
					if (error.data.error == "SolicitudAmistadExistException") {
						$scope.existSolicitud = true;
					} else {
						$scope.error = true;
					}
					scrollToTop();
				});
	};

	$scope.eliminarAmigo = function() {
		UserService.updateAmigosUser($rootScope.user.login, $scope.usuario.login, false)
		.then(function success(response){
			obtenerAmigos();
			obtenerLogrosPublicos();
			$scope.amigo=false;
			$scope.eliminarAmigoOk=true;
			$scope.eliminarAmigoKo=false;
			$scope.solicitudOk = false;
			$scope.existSolicitud = false;
			$scope.error = false;
			scrollToTop();
		},function error(error){
			$scope.eliminarAmigoOk=false;
			$scope.eliminarAmigoKo=true;
			$scope.solicitudOk = false;
			$scope.existSolicitud = false;
			$scope.error = false;
			scrollToTop();
		});
	
	}
	
	function obtenerAmigos() {
		UserService.getAmigos($rootScope.user.login).then(
			function success(response) {
				$rootScope.user.amigos = response;
			}, function error(error) {
				$rootScope.user.amigos = {};
			});

	}
	;
	
	function obtenerLogrosPublicos(){
		jQuery.each($scope.usuario.logros, function(i, logro) {
			if (logro.tipoVisibilidad.tipoVisibilidad === "amigos") { //ya son amigos
				$scope.usuario.logros.splice(i,1);
			}
		});
	}
	
	/**
	 * Abrir el juego seleccionado
	 */
	$scope.openGame = function (idJuego) {
		
		if(idJuego){//tengo usuario seleccionado
			$location.path("/home/juegos/"+idJuego);
		}
	};
});